#include "main.h"
#include "monetra.h"

void M_init_locks(M_CONN *conn)
{
	if ((*conn)->mutexreg != NULL) {
		(*conn)->mutex = (*((*conn)->mutexreg))();
	}
}

void M_destroy_locks(M_CONN *conn)
{
	if (
		((*conn)->mutex      != NULL) &&
		((*conn)->mutexunreg != NULL)
	) {
		(*((*conn)->mutexunreg))((*conn)->mutex);
		(*conn)->mutex = NULL;
	}
}

void M_lock(M_CONN *conn)
{
	if (
		((*conn)->mutex     != NULL) &&
		((*conn)->mutexlock != NULL)
	) {
		(*((*conn)->mutexlock))((*conn)->mutex);
	}
}

void M_unlock(M_CONN *conn)
{
	if (
		((*conn)->mutex       != NULL) &&
		((*conn)->mutexunlock != NULL)
	) {
		(*((*conn)->mutexunlock))((*conn)->mutex);
	}
}
