#ifndef __BASE64_H__
#define __BASE64_H__

#define B64_LINELEN 65
#define B64_TARGSIZE_INT(n) (((n + 2 - ((n + 2) % 3)) * 4 / 3) + 1)
#define B64_TARGSIZE(srcsize) (B64_TARGSIZE_INT(srcsize) + ((B64_TARGSIZE_INT(srcsize) / B64_LINELEN) + 1) + 1)

int libmonetra_base64_decode(const char *source, unsigned long source_size, char *target, unsigned long target_size);
int libmonetra_base64_encode(const char *source, unsigned long source_size, char *target, unsigned long target_size);
#define base64_decode(a,b,c,d) libmonetra_base64_decode(a,b,c,d)
#define base64_encode(a,b,c,d) libmonetra_base64_encode(a,b,c,d)

#endif
