#ifndef __UTILS_H__
#define __UTILS_H__

#include "monetra.h"
#include "main.h"

void UnescapeQuotes(char *quoted_data);
int M_SendTransaction(M_CONN *myconn, M_QUEUE *queue);
int Ml_verify_trans_in_queue(M_CONN *myconn, M_uintptr identifier);
int Ml_pattern_match(const char *pattern, const char *str);
char **Ml_str_explode(char delim, const char *s, size_t s_len, int *num, int **len_array);
void Ml_str_explode_free(char **strs, size_t num);
char **Ml_str_explode_str(char delim, const char *s, int *num);
int Ml_str_cpy(char *dest, const char *src, size_t dest_len);
void Ml_str_lower(char *str);
char *Ml_str_implode(char delim_char, char enclose_char, char escape_char, char **strs, size_t num_strs, int always_enclose);

#endif
